## nds2-client-swig 0.16.13

=== CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4
#------------------------------------------------------------------------
#
# DEFINES:
#   CMAKE_INSTALL_PREFIX  - Installation prefix
#   MATLAB_NO_NODISPLAY   - Run the matlab tests w/o using the -nodisplay option
#   PROG_MATLAB           - Full path to MATLAB executable
#   REPLAY_BLOB_CACHE_DIR - Directory containing replay blobs for testing
#------------------------------------------------------------------------
cmake_minimum_required( VERSION 3.0 FATAL_ERROR )

set(NDS_HOME_PAGE_URL "https://wiki.ligo.org/Computing/NDSClient")
set(NDS_SOURCE_URL "https://software.igwn.org/lscsoft/source")

set( NDS_CLIENT_SWIG_VERSION 0.16.13)
set( NDS_CLIENT_VERSION 0.16.9)

project(nds2-client-swig
    VERSION "${NDS_CLIENT_SWIG_VERSION}"
    LANGUAGES C CXX)

set( CMAKE_CXX_STANDARD 11 )

set( NDS_CONFIG_PATH "${CMAKE_CURRENT_SOURCE_DIR}/config/cmake/")
set( PROJECT_BASENAME nds2-client )

set( CMAKE_MODULE_PATH "${NDS_CONFIG_PATH}/Modules;${CMAKE_MODULE_PATH}" )
set( CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE )

include(UseNDS)
include(Cpp11)
include(CheckIncludeFileCXX)

include(CheckCXXCompilerFlag)
include(GNUInstallDirs)
if ( NOT DEFINED CMAKE_INSTALL_PKGDATADIR )
    set( CMAKE_INSTALL_PKGDATADIR ${CMAKE_INSTALL_DATADIR}/nds2-client )
endif( )

cond_set_policy( CMP0042 NEW )
cond_set_policy( CMP0068 NEW )

if (COMBINED_BUILD)
    add_library(nds::cxx ALIAS ndscxx)
    add_library(nds::daqc ALIAS ndsclient)
    set(CONLIBNDSCXX_OBJECTS $<TARGET_OBJECTS:ndscxx_obj>)

    get_target_property(nds2-client_INCLUDE_DIRS nds::cxx INCLUDE_DIRECTORIES)

    message("nds::cxx includes = ${nds2-client_INCLUDE_DIRS}")

    set( NDSTester_FOUND "${CMAKE_CURRENT_SOURCE_DIR}/../client/tests/nds_tester.py" )
    get_filename_component( PROG_NDS_TESTER "${NDSTester_FOUND}" ABSOLUTE)
    get_filename_component ( ABS_TESTERDIR "${CMAKE_CURRENT_SOURCE_DIR}/../client/tests/" ABSOLUTE)
else()
    include(ax_packaging)
    find_package( nds2-client REQUIRED ${NDS_CLIENT_VERSION})
    file( GLOB CONLIBNDSCXX_OBJECTS ${CONLIBNDSCXX_LIBRARY_DIRS}/* )

    find_package(
            NDSTester 0.15.3 REQUIRED
            HINTS ${nds2-client_DIR} )
endif()

include(Autotools/Archive/Archive)
include(Autotools/ArchiveX/ArchiveX)

set( NDS_TESTER_FOUND ${NDSTester_FOUND} )
if ( NDS_TESTER_FOUND )
    set(NDS_TESTER_FLAGS
            "--builddir=\${CMAKE_CURRENT_BINARY_DIR}"
            "--abs-top-srcdir=${CMAKE_CURRENT_SOURCE_DIR}"
            "--abs-srcdir=\${CMAKE_CURRENT_SOURCE_DIR}"
            "--abs-top-builddir=${CMAKE_CURRENT_BINARY_DIR}"
            "--abs-testerdir=${ABS_TESTERDIR}"
            )
endif()

#========================================================================
# Local macros
#========================================================================

macro(is_enabled _VARNAME)
  # ---------------------------------------------------------------------
  #
  # ---------------------------------------------------------------------
  if( ${_VARNAME} )
    set(IS_ENABLED_VALUE "ENABLED")
  else ()
    set(IS_ENABLED_VALUE "DISABLED")
  endif ()
endmacro(is_enabled)

function(set_nds_protocols variable TEST_NAME)
    string(REPLACE "_" ";" name_list ${TEST_NAME})
    list(SORT name_list)
    list(REMOVE_DUPLICATES name_list)
    list(REMOVE_ITEM name_list "")
    ## message(STATUS "DEBUG: set_nds_protocols: name_list: ${name_list}")

    list(FIND name_list nds1 _index)
    if (${_index} GREATER -1)
        set(protocol_list ${NDS_TESTING_PROTOCOLS_NDS1})
    endif (${_index} GREATER -1)

    list(FIND name_list nds2 _index)
    if (${_index} GREATER -1)
        set(protocol_list ${NDS_TESTING_PROTOCOLS_NDS2})
    endif (${_index} GREATER -1)
    list(LENGTH protocol_list len)
    if ( NOT DEFINED protocol_list )
        message(FATAL_ERROR "Unable to determine NDS protocol for test ${TEST_NAME}")
    endif ( NOT DEFINED protocol_list )
    ## message(STATUS "DEBUG: set_nds_protocols: protocol_list: ${protocol_list}")
    set(${variable} ${protocol_list} PARENT_SCOPE)
endfunction(set_nds_protocols)

macro( unquote VAR )
    #--------------------------------------------------------------------
    # Removes outer most level of quotation.
    #--------------------------------------------------------------------
    string( STRIP "${${VAR}}" ${VAR} )
    string( REGEX REPLACE "^\"(.*)\"$" "\\1" ${VAR} ${${VAR}} )
endmacro( unquote VAR )

function( verify_release_info filename pattern )
    #--------------------------------------------------------------------
    # verifies that file has string pattern for release.
    #--------------------------------------------------------------------
    file(READ ${filename} buffer)
    string( FIND "${buffer}" ${pattern} matchres )
    if( ${matchres} EQUAL -1 )
        message( FATAL_ERROR "File: ${filename} has not been updated for release ${pattern}" )
    else( )
        message( STATUS "File: ${filename} has been updated for release ${pattern}" )
    endif( )
endfunction( )

#========================================================================
# Release version number
#========================================================================
set( PACKAGE_NAME ${PROJECT_NAME} )
set( PACKAGE_VERSION ${${PROJECT_NAME}_VERSION} )

# The following line is an input marker for some sed work when doing a
# CI build, it is used to inject an updated version tag when building
# a deb/rep/...  so it is only used on a copy of this file.
##CI_code_version_update

verify_release_info( "${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog.md" "${PROJECT_NAME}-${PROJECT_VERSION}")
verify_release_info( "${CMAKE_CURRENT_SOURCE_DIR}/debian/changelog" "${PROJECT_NAME} (${PROJECT_VERSION}-1)")

#========================================================================
# Prepare for testing
#========================================================================

if ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS1 )
    set( NDS_TESTING_PROTOCOLS_NDS1
        nds1-12_2 )
endif ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS1 )
if ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS2 )
    set( NDS_TESTING_PROTOCOLS_NDS2
        nds2-1_6 nds2-1_5 )
endif ( NOT DEFINED NDS_TESTING_PROTOCOLS_NDS2 )
if ( DEFINED CTEST_TESTING_TIMEOUT )
    set( CTEST_TESTING_TIMEOUT 60 )
endif ( DEFINED CTEST_TESTING_TIMEOUT )

if( NOT CTEST_MEMORYCHECK_COMMAND )
    find_program( CTEST_MEMORYCHECK_COMMAND NAMES valgrind )
endif( NOT CTEST_MEMORYCHECK_COMMAND )
if( NOT MEMORYCHECK_COMMAND )
    set( MEMORYCHECK_COMMAND ${CTEST_MEMORYCHECK_COMMAND} )
endif( NOT MEMORYCHECK_COMMAND )

if( NOT CTEST_MEMORYCHECK_COMMAND_OPTIONS )
    set( CTEST_MEMORYCHECK_COMMAND_OPTIONS "--trace-children=yes --leak-check=full" )
endif( NOT CTEST_MEMORYCHECK_COMMAND_OPTIONS )
if( NOT MEMORYCHECK_COMMAND_OPTIONS )
    set( MEMORYCHECK_COMMAND_OPTIONS ${CTEST_MEMORYCHECK_COMMAND_OPTIONS} )
endif( NOT MEMORYCHECK_COMMAND_OPTIONS )


include( CTest )


# message( FATAL_ERROR "DEBUG: NDS_TESTER_FOUND: ${NDS_TESTER_FOUND}" )

#========================================================================
# Prepare for distribuition
#========================================================================
#   G e n e r a l
#------------------------------------------------------------------------
set( CPACK_PACKAGE_VENDOR "LIGO" )
set( CPACK_PACKAGE_MAJOR ${${PROJECT_NAME}_MAJOR_VERSION} )
set( CPACK_PACKAGE_MINOR ${${PROJECT_NAME}_MINOR_VERSION} )
set( CPACK_PACKAGE_PATCH ${${PROJECT_NAME}_PATCH_VERSION} )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "Client interface to NDS and NDS2 servers" )
set( CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_MAJOR}.${CPACK_PACKAGE_MINOR}.${CPACK_PACKAGE_PATCH}" )
#------------------------------------------------------------------------
#   S O U R C E
#------------------------------------------------------------------------
set( CPACK_SOURCE_GENERATOR TBZ2 )
set( CPACK_SOURCE_PACKAGE_FILE_NAME
     ${PROJECT_NAME}-${${PROJECT_NAME}_VERSION} )
#set( CPACK_SYSTEM_NAME noarch )
set( CPACK_SOURCE_IGNORE_FILES "/.*~$/;/(CVS|autom4te[.]cache)/;/[.]svn/;[.]swap$;[.]#;.*~$;cscope.*")

include(CPack)

cpack_add_component_group(Runtime
                          DESCRIPTION "Pieces needed for running")

#========================================================================
# Find import pieces
#========================================================================

find_package(SWIG 3.0.7 REQUIRED)
if( SWIG_FOUND)
    if( DEFINED SWIG_USE_FILE )
        include(${SWIG_USE_FILE})
    else( )
        include(UseSWIG)
    endif( )
endif( )

message( STATUS "DEBUG: NDS_CLIENT_LIBRARIES: ${NDS_CLIENT_LIBRARIES}" )
message( STATUS "DEBUG: NDS_CLIENT_CFLAGS: ${NDS_CLIENT_CFLAGS}" )
message( STATUS "DEBUG: NDS_CLIENT_INCLUDE_DIRS: ${NDS_CLIENT_INCLUDE_DIRS}" )

#========================================================================
# Get the default python interpreter for testing purposes
#========================================================================

cx_python( PREFIX PYTHON_DFLT VERSION ${PYTHON3_VERSION} )
find_program( PROG_MATLAB matlab )

#========================================================================
# Handle the target languages
#========================================================================

set( SUBPORTS
    ${PROJECT_BASENAME}-java
    ${PROJECT_BASENAME}-matlab
    # ${PROJECT_BASENAME}-octave
    py27-${PROJECT_BASENAME}
    py34-${PROJECT_BASENAME}
    py35-${PROJECT_BASENAME}
    py36-${PROJECT_BASENAME}
    )

add_subdirectory(common)
add_subdirectory(python)
add_subdirectory(java)
add_subdirectory(octave)

add_subdirectory(matlab)

#========================================================================
# Generation of documentation
#========================================================================

find_package(Doxygen)

if(DOXYGEN_FOUND)
  configure_file(
      ${CMAKE_CURRENT_SOURCE_DIR}/manual.txt.in
      ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
      @ONLY )
  #--------------------------------------------------------------------
  # User documentation
  #--------------------------------------------------------------------
  cx_target_manual(
    TARGET SwigUser
    OUTPUT_NAME User
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "USER_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    HIDE_UNDOC_MEMBERS
    HIDE_UNDOC_CLASSES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
  cx_target_manual(
    TARGET SwigDeveloper
    OUTPUT_NAME Developer
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "DEVELOPER_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    EXTRACT_ALL
    EXTRACT_PRIVATE
    EXTRACT_STATIC
    EXTRACT_LOCAL_CLASSES
    EXTRACT_LOCAL_METHODS
    EXTRACT_ANON_NSPACES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
  cx_target_manual(
    TARGET SwigAdministrator
    OUTPUT_NAME Administrator
    TEMPLATE ${CMAKE_CURRENT_SOURCE_DIR}/NDSClientDoc.cfg.in
    ENABLE_SECTIONS "ADMIN_SECTION"
    MAIN_PAGE ${CMAKE_CURRENT_BINARY_DIR}/manual.txt
    HIDE_UNDOC_MEMBERS
    HIDE_UNDOC_CLASSES
    EXCLUDE_PATTERNS */sqlite3.* */test/* */CMakeLists.txt *.in
    )
endif(DOXYGEN_FOUND)

#========================================================================
# Provide additional information regarding components
#========================================================================
cpack_add_component(Development
    DISPLAY_NAME "SWIG  extensions"
    DESCRIPTION
        "Pieces needed to build extensions to the nds2 client using SWIG"
        )

#========================================================================
# Testing of the packaging
#========================================================================
if (NOT COMBINED_BUILD)
    set( AX_SOURCE_SPEC_FILENAME "${NDS_CONFIG_PATH}/${PROJECT_NAME}.spec.in" )

=== java/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4
find_package(SWIG 2.0.4 REQUIRED)

#========================================================================
# Discover if JAVA is available and usable
#========================================================================
if ( NOT DEFINED ENABLE_SWIG_JAVA OR ENABLE_SWIG_JAVA )
    find_package(Java)
    find_package(JNI)
endif( )

if ( JAVA_FOUND AND JNI_FOUND )

    #--------------------------------------------------------------------
    # Since it is available and usable, finish up with making it
    #   usable
    #--------------------------------------------------------------------
    include(UseJava)
    set( ENABLE_SWIG_JAVA "yes"
        CACHE BOOL "Control the building of the SWIG bindings for Java" )

    #--------------------------------------------------------------------
    # Test for compatibility
    #--------------------------------------------------------------------
    file( WRITE ${CMAKE_CURRENT_BINARY_DIR}/compatibility_check.java "" )
    set( JAVA_COMPATIBILITY_REGEX_ "^.* (obsolete|no longer supported[.]) .*$" )
    foreach( JAVA_COMPATIBILITY_ 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 )
        message( STATUS "Checking ${Java_JAVAC_EXECUTABLE} for ${JAVA_COMPATIBILITY_}" )
        execute_process(
            COMMAND ${Java_JAVAC_EXECUTABLE}
            -source ${JAVA_COMPATIBILITY_}
            -target ${JAVA_COMPATIBILITY_}
            ${CMAKE_CURRENT_BINARY_DIR}/compatibility_check.java
            OUTPUT_VARIABLE OUTPUT_STRING
            ERROR_VARIABLE ERROR_STRING
            OUTPUT_STRIP_TRAILING_WHITESPACE
            ERROR_STRIP_TRAILING_WHITESPACE
            )
        message( STATUS "LOOKING FOR '${JAVA_COMPATIBILITY_REGEX_}' IN: ${ERROR_STRING}" )
        string( REGEX REPLACE "${JAVA_COMPATIBILITY_REGEX_}" "" OBSOLETE_FOUND_STRING "${ERROR_STRING}" )
        message( STATUS "OBSOLETE_FOUND_STRING ${OBSOLETE_FOUND_STRING}" )
        string( LENGTH "${OBSOLETE_FOUND_STRING}" OBSOLETE_FOUND )
        if ( OBSOLETE_FOUND GREATER 0 )
            set( JAVA_COMPATIBILITY ${JAVA_COMPATIBILITY_} CACHE INTERNAL "Backwards compatibility level" )
            break( )
        endif( )
    endforeach()
    file( REMOVE ${CMAKE_CURRENT_BINARY_DIR}/compatibility_check.java )
    message( STATUS "Compiling code to be backwards compatible with Java ${JAVA_COMPATIBILITY}" )

    #--------------------------------------------------------------------
    # 
    #--------------------------------------------------------------------
    if ( ${Java_VERSION_STRING} GREATER "1.8"  )
        set( NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH "" )
    else ( ${Java_VERSION_STRING} GREATER "1.8"  )
        if ( UNIX AND NOT APPLE )
            execute_process(
                COMMAND ${Java_JAVA_EXECUTABLE} -XshowSettings:properties -help
                OUTPUT_QUIET
                ERROR_VARIABLE _PROPERTIES
                )
            # message( STATUS "DEBUG: Setting JAVA PROPERTIES to: ${Java_JAVA_EXECUTABLE}" ${_PROPERTIES} )
            string( REGEX MATCH "sun.boot.library.path = [^\n]*"
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                ${_PROPERTIES} )
            string( REPLACE "sun.boot.library.path = " ""
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
            string( STRIP
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH )
            file( TO_CMAKE_PATH
                ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}
                NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH )
            set( NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH
                "LD_LIBRARY_PATH=${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}/xawt" )
            message( STATUS "DEBUG: Setting JAVA LIB to: ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH}" )
        endif ( UNIX AND NOT APPLE )
    endif ( ${Java_VERSION_STRING} GREATER "1.8"  )
endif( JAVA_FOUND
    AND JNI_FOUND)

add_subdirectory(module)
add_subdirectory(test)

#========================================================================
# Provide additional information regarding components
#========================================================================

cpack_add_component(JAVA
    DISPLAY_NAME "JAVA extensions"
    DESCRIPTION
        "Pieces needed to use the nds2 client from JAVA"
    GROUP Runtime)

=== octave/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4

#========================================================================
# Discover if Octave is available and usable
#========================================================================
set( _OCTAVE_MINIMUM 3.0 )
set( _OCTAVE_MAXIMUM 6.0 )

if (APPLE AND UNIX AND NOT DEFINED ENABLE_SWIG_OCTAVE)
    #--------------------------------------------------------------------
    # Currently there is an issue were SWIG and Octave are incompatable
    #   under MacPorts
    #--------------------------------------------------------------------
    set(ENABLE_SWIG_OCTAVE FALSE)
endif()
if ( NOT DEFINED ENABLE_SWIG_OCTAVE OR ENABLE_SWIG_OCTAVE )
    find_package(HDF5)
    find_package(Octave)
    if ( OCTAVE_FOUND AND
            ( ( OCTAVE_VERSION_STRING VERSION_LESS ${_OCTAVE_MINIMUM} ) OR
              ( OCTAVE_VERSION_STRING VERSION_EQUAL ${_OCTAVE_MAXIMUM} ) OR
              ( OCTAVE_VERSION_STRING VERSION_GREATER ${_OCTAVE_MAXIMUM} ) ) )
        #----------------------------------------------------------------
        # NOT in range of what is supported
        #----------------------------------------------------------------
        get_property( _helpstring CACHE OCTAVE_FOUND PROPERTY HELPSTRING )
        if ( NOT _helpstring )
            set( _helpstring "State of having found Octave" )
        endif( )
        get_property( _type CACHE OCTAVE_FOUND PROPERTY TYPE )
        if ( NOT _type )
            set( _type BOOL )
        endif( )
        message( INFO "_helpstring: ${_helpstring}" )
        message( INFO "_type: ${_type}" )
        set( OCTAVE_FOUND False CACHE ${_type} ${_helpstring} FORCE )
    endif( )
endif( )

if (OCTAVE_FOUND AND SWIG_FOUND)
  set( ENABLE_SWIG_OCTAVE "yes"
      CACHE BOOL "Control the building of the SWIG bindings for Octave" )
  set( OCTAVE_VERSION_STRING ${OCTAVE_VERSION_STRING} PARENT_SCOPE )
  find_program( OCTAVE_CONFIG_PROGRAM octive-config )

  if ( OCTAVE_CONFIG_PROGRAM_FOUND )
      execute_process(
          COMMAND ${OCTAVE_CONFIGURE_PROGRAM} --print OCTLIBDIR
          RESULT_VARIABLE OCTAVE_OCTLIBDIR )
  endif( )
  # ---------------------------------------------------------------------
  # Library: octave
  # ---------------------------------------------------------------------
  find_library( OCTAVE_OCTAVE_LIBRARY
      NAMES octave
		  HINTS ${OCTAVE_LINK_DIRS} )
  find_library( OCTAVE_INTERP_LIBRARY
      NAMES octinterp
		  HINTS ${OCTAVE_LINK_DIRS} )
  set( OCTAVE_LIBRARIES
       ${OCTAVE_INTERP_LIBRARY}
       ${OCTAVE_OCTAVE_LIBRARY} )

else( )
  set( ENABLE_SWIG_OCTAVE "no"
       CACHE BOOL "Control the building of the SWIG bindings for Octave" FORCE )
endif(OCTAVE_FOUND AND SWIG_FOUND)

add_subdirectory(module)
add_subdirectory(test)

#========================================================================
# Provide additional information regarding components
#========================================================================

cpack_add_component(Octave
    DISPLAY_NAME "Octave extensions"
    DESCRIPTION
        "Pieces needed to use the nds2 client from Octave"
    GROUP Runtime)

=== python/CMakeLists.txt ===
add_subdirectory(module)
add_subdirectory(test)

# add_subdirectory(python2)
add_subdirectory(python3)

=== java/module/CMakeLists.txt ===
# -*- mode: cmake; coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4
cmake_minimum_required(VERSION 2.8.6)

if ( ENABLE_SWIG_JAVA )

    function(SET_NDS_JAVA_LIBRARY_DIR BUILD_TYPE)
        if (WIN32)
            string(TOUPPER ${BUILD_TYPE} BUILD_TYPE_UPPER)
            set( NDS_LIBRARY_DIR $ENV{PATH} )
            list( INSERT NDS_LIBRARY_DIR 0 "${CMAKE_BINARY_DIR}/bin/${BUILD_TYPE}" )
            set( TMP_NDS_LIBRARY_DIR "" )
            foreach( TMP ${NDS_LIBRARY_DIR} )
                file( TO_NATIVE_PATH ${TMP} TMP )
                string( REPLACE "\\" "\\\\" TMP ${TMP} )
                string( LENGTH "${TMP_NDS_LIBRARY_DIR}" L )
                if( $L LESS 1 )
                    set( TMP_NDS_LIBRARY_DIR ${TMP} )
                else( $L LESS 1 )
                    set( TMP_NDS_LIBRARY_DIR "${TMP_NDS_LIBRARY_DIR}\\\\;${TMP}" )
                endif( $L LESS 1 )
            endforeach( TMP )
            #join( ${TMP_NDS_LIBRARY_DIR} ";" NDS_LIBRARY_DIR )
            set( NDS_LIBRARY_DIR ${TMP_NDS_LIBRARY_DIR} )
            #get_target_property( NDS_LIBRARY_DIR nds2JNI LIBRARY_OUTPUT_DIRECTORY )
            set(BUILD_TYPE_UPPER "_${BUILD_TYPE_UPPER}")
        else (WIN32)
            set(BUILD_TYPE_UPPER "")
            get_target_property( NDS_LIBRARY_DIR nds2 LIBRARY_OUTPUT_DIRECTORY )
        endif(WIN32)
        set( NDS_LIBRARY${BUILD_TYPE_UPPER}_DIR "${NDS_LIBRARY_DIR}"
            CACHE INTERNAL "Internal" )
        set( NDS_LIBRARY_DIR "${NDS_LIBRARY_DIR}"
            CACHE INTERNAL "Internal" )
    endfunction(SET_NDS_JAVA_LIBRARY_DIR )

    set(NDS2_JAR_PACKAGING FALSE
        CACHE PATH "True if the Java bindings should be distributed as a jar file." )


    include_directories( BEFORE
        ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}/../../common/module
        ${CMAKE_CURRENT_SOURCE_DIR}/../../common/module
        ${nds2-client_INCLUDE_DIRS}
        ${JNI_INCLUDE_PATH}
        ${JAVA_INCLUDE_PATH}
        ${JAVA_INCLUDE_PATH2}
        )
    include_directories(AFTER "/usr/include")


    set(INTERFACE_FILE "${CMAKE_CURRENT_SOURCE_DIR}/nds_java.i")
    set(WRAPPER_FILE "nds2_wrap.cc")
    set(CMAKE_JNI_TARGET true)
    set(built_java_sources
        nds2/availability.java
        nds2/availability_list_type.java
        nds2/availabilityListType.java
        nds2/buffer.java
	      nds2/channel.java
        nds2/channel_names_type.java
	      nds2/connection.java
	      nds2/connection_iterator.java
        nds2/epoch.java
        nds2/epochs_type.java
        nds2/nds2.java
        nds2/segment.java
        nds2/segment_list_type.java
        nds2/simple_availability_list_type.java
        nds2/simple_segment.java
        nds2/simple_segment_list_type.java
        nds2/SWIGTYPE_p_channel__hash_type.java
        nds2/vectorEpochs.java
        nds2/vectorSegment.java
        nds2/vectorSimpleSegment.java
        nds2/vectorSimpleSegmentListType.java
        nds2/channel_predicate.java
        nds2/request_period.java
        nds2/parameters.java
	      nds2/nds2JNI.java)
    set(built_java_classes "")
    set(pathed_built_java_sources "")
    foreach(_NDS_FILE ${built_java_sources})
        string(REGEX REPLACE "^nds2/" ""
            _built_java_class ${_NDS_FILE})
        string(REGEX REPLACE ".java$" ".class"
            _built_java_class ${_built_java_class})
        set(built_java_classes ${built_java_classes} ${_built_java_class})
        set( pathed_built_java_sources
            ${pathed_built_java_sources}
            "${CMAKE_CURRENT_BINARY_DIR}/${_NDS_FILE}" )
    endforeach(_NDS_FILE ${built_java_sources})

    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/nds2/connection_iterator.java
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_CURRENT_SOURCE_DIR}/connection_iterator.java ${CMAKE_CURRENT_BINARY_DIR}/nds2/connection_iterator.java
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        )

    set(CMAKE_SWIG_FLAGS -O -package nds2)
    set(CMAKE_SWIG_OUTDIR nds2)
    set_property(SOURCE ${INTERFACE_FILE} PROPERTY CPLUSPLUS ON)
    set(_build_java_sources_cmd "")

    set_source_files_properties(${WRAPPER_FILE} PROPERTIES GENERATED true)
    set(CMAKE_JAVA_COMPILE_FLAGS -source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY} )
    set(CMAKE_JAVAC_WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    set(CMAKE_JAVA_CLASS_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR}/nds2)
    set_source_files_properties(${built_java_sources} PROPERTIES GENERATED true)

    # -------------------------------------------------------------------
    # swig_add_module(nds2JNI java ${INTERFACE_FILE})
    # -------------------------------------------------------------------
    add_custom_command(
        OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${WRAPPER_FILE}"
        DEPENDS
        COMMAND ${CMAKE_COMMAND}
        ARGS    -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SWIG_OUTDIR}
        COMMAND ${SWIG_EXECUTABLE}
        ARGS    -java -c++ ${CMAKE_SWIG_FLAGS}
        -I${CMAKE_CURRENT_BINARY_DIR}
        -I${CMAKE_CURRENT_SOURCE_DIR}
        -I${PROJECT_BINARY_DIR}/common/module
        -I${PROJECT_SOURCE_DIR}/common/module
        -o ${WRAPPER_FILE}
        -outdir ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SWIG_OUTDIR}
        ${INTERFACE_FILE}
        )
    # -------------------------------------------------------------------
    # swig_link_libraries(nds2JNI -static-libstdc++ ${JNI_LIBRARIES} $<TARGET_OBJECTS:ndswrapcxx_obj> ndsclient)
    # -------------------------------------------------------------------
    add_library( nds2JNI SHARED
        "${CMAKE_CURRENT_BINARY_DIR}/${WRAPPER_FILE}"
        )
    target_link_libraries( nds2JNI
        -static-libstdc++
        ${CONLIBNDSCXX_OBJECTS}
        ${JNI_LIBRARIES}
        nds::daqc
        )
    if( WIN32 )
        target_link_libraries( nds2JNI nds::cxx Ws2_32 )
    endif( WIN32 )

    target_requires_cpp11(nds2JNI PUBLIC)
    if (WIN32)
        #................................................................
        # Windows
        #................................................................
        add_custom_command(TARGET nds2JNI POST_BUILD
            COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE_DIR:nds2JNI>/$<TARGET_FILE_NAME:nds2JNI> ${CMAKE_CURRENT_BINARY_DIR}/libnds2JNI.jnilib)
    else (WIN32)
        #................................................................
        # Un*x / OSX
        #................................................................
        set_target_properties(nds2JNI
    	      PROPERTIES
            LIBRARY_OUTPUT_DIRECTORY nds2
    	      PREFIX lib
    	      SUFFIX .jnilib)
        if ( APPLE )
            set_target_properties(nds2JNI
    	          PROPERTIES
                INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}"
                BUILD_WITH_INSTALL_RPATH TRUE )
        endif ( APPLE )
    endif(WIN32)

    #--------------------------------------------------------------------
    # Build the JAR library
    #--------------------------------------------------------------------
    add_jar(nds2 ${built_java_sources})
    add_dependencies(nds2 nds2JNI)
    #--------------------------------------------------------------------
    # Build java documentation
    #--------------------------------------------------------------------
    if( NOT WIN32 )
        create_javadoc(
            nds2
            FILES ${pathed_built_java_sources}
            CLASSPATH ${CMAKE_JAVA_INCLUDE_PATH}
            INSTALLPATH ${CMAKE_INSTALL_DATADIR}/nds2-client/java
            WINDOWTITLE "NDS2 Client Interface"
            DOCTITLE "<h1>NDS2 Client Interface</h1>"
            AUTHOR TRUE
            USE TRUE
            VERSION TRUE
            )
        add_dependencies( nds2_javadoc nds2 )
    endif( NOT WIN32 )

    #--------------------------------------------------------------------
    # Create JAR of documentation
    #--------------------------------------------------------------------
    if( NOT WIN32 )
        add_custom_target(nds2_javadoc_jar
            ALL
            COMMAND ${CMAKE_COMMAND} -E echo ${JAVA_ARCHIVE} -cvf ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar "."
    	      COMMAND ${JAVA_ARCHIVE} -cvf ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar "."
    	      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/javadoc/nds2"
    	      DEPENDS nds2_javadoc)
    endif( NOT WIN32 )
    #--------------------------------------------------------------------
    # Add the JNI library to the jar archive
    #--------------------------------------------------------------------
    add_custom_target(nds2JNIinclusion
        ALL
        COMMAND ${CMAKE_COMMAND} -E copy
        $<TARGET_FILE_DIR:nds2JNI>/$<TARGET_FILE_NAME:nds2JNI> "${CMAKE_CURRENT_BINARY_DIR}/nds2"
    	  COMMAND ${JAVA_ARCHIVE} uvf ${CMAKE_CURRENT_BINARY_DIR}/nds2.jar "nds2/$<TARGET_FILE_NAME:nds2JNI>"
    	  DEPENDS nds2)
    set( FILENAME_NDS2_JAR "${CMAKE_CURRENT_BINARY_DIR}/nds2.jar" )
    #====================================================================
    # Report the configuration
    #====================================================================
    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/nds2-client-java.cfg.in
        ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-java.cfg
	      @ONLY )
    #====================================================================
    # Distribution rules
    #====================================================================
    if( NOT WIN32)
        install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2-client-java.cfg
            DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${PROJECT_BASENAME}
            COMPONENT JAVA
            )
    endif( NOT WIN32)

    install(
        FILES "${FILENAME_NDS2_JAR}"
        RENAME "nds2.jar"
	      DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java
	      COMPONENT JAVA
        )
    if ( NOT WIN32 )
        install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/nds2_javadoc.jar
            DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java
            COMPONENT JAVA
            )
    endif ( NOT WIN32 )
    foreach(_NDS_FILE ${built_java_classes})
	      install(
            FILES ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/nds2.dir/nds2/${_NDS_FILE}
	          DESTINATION ${CMAKE_INSTALL_LIBDIR}/nds2-client/java/nds2
	          COMPONENT JAVA)
    endforeach(_NDS_FILE)

    install(TARGETS nds2JNI
	      DESTINATION ${CMAKE_INSTALL_LIBDIR}/java/nds2
	      COMPONENT JAVA)
    if (WIN32)
        install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libnds2JNI.jnilib
	          DESTINATION ${CMAKE_INSTALL_LIBDIR}/java/nds2
            COMPONENT JAVA)
    endif(WIN32)

    set_nds_java_library_dir( "Release" )
    set_nds_java_library_dir( "Debug" )

ENDIF ( ENABLE_SWIG_JAVA )

=== java/test/CMakeLists.txt ===
# -*- coding: utf-8; cmake-tab-width: 4; indent-tabs-mode: nil; -*- vim:fenc=utf-8:ft=cmake:et:sw=4:ts=4:sts=4

macro(set_testing_path)
    if( WIN32 )
        foreach( dir ${NDS_CLIENT_LIBRARY_DIRS} )
            get_filename_component( dir "${dir}/../bin" ABSOLUTE )
            file( TO_NATIVE_PATH ${dir} dir )
            list( APPEND TPATH ${dir} )
        endforeach( )
        list( APPEND TPATH  $ENV{PATH} )
        string( REPLACE ";" "\\;" TPATH "${TPATH}" )
        # message( FATAL_ERROR "DEBUG: TPATH: ${TPATH}" )
    else( WIN32 )
        set(TPATH "$ENV{PATH}")
    endif( WIN32 )
endmacro()

if ( ENABLE_SWIG_JAVA )
    include(CMakeParseArguments)
    include(UseCopyIfDifferent)

    file( TO_NATIVE_PATH ${Java_JAVA_EXECUTABLE} PROG_JAVA )
    if ( WIN32 )
        # string( REPLACE "\\" "\\\\" PROG_JAVA "${PROG_JAVA}" )
    endif( )

    get_filename_component( NDS_JAR "${CMAKE_CURRENT_BINARY_DIR}/../module/nds2.jar" ABSOLUTE )
    message( STATUS "NDS_JAR: ${NDS_JAR}" )

    set( MATLAB_TEST_FLAGS "")
    if ( MATLAB_NO_NODISPLAY )
        set ( MATLAB_TEST_FLAGS "--no-nodisplay" )
    endif ( MATLAB_NO_NODISPLAY )

    function(to_path_list var path1)
        if (WIN32)
            set(sep "\\;")
        else(WIN32)
            set(sep ":")
        endif(WIN32)
        set(result "${path1}") # First element doesn't require separator at all...
        foreach(path ${ARGN})
            set(result "${result}${sep}${path}") # ... but other elments do.
        endforeach(path)
        #list(APPEND result ${path1} ${ARGN})
        set(${var} "${result}" PARENT_SCOPE)
    endfunction(to_path_list)


    function(COMPILE_JAVA target)
        #--------------------------------------------------------------------
        # Parse the parameters
        #--------------------------------------------------------------------
        set(options)
        set(oneValueArgs)
        set(multiValueArgs SOURCES BINARY_SOURCES)
        cmake_parse_arguments( "" "${options}" "${oneValueArgs}" "${multiValueArgs}" ${ARGN} )
        message( STATUS "target: ${target} ARGN: ${ARGN}" )
        set(ALL_SOURCES "" )
        if( _SOURCES )
          set_source_files_properties( ${_SOURCES} PROPERTIES GENERATED TRUE )
          foreach( i ${_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _SOURCES )
        message( STATUS "BINARY_SOURCES: ${_BINARY_SOURCES}" )
        if( _BINARY_SOURCES )
            foreach( i ${_BINARY_SOURCES} )
                list( APPEND ALL_SOURCES "${CMAKE_CURRENT_BINARY_DIR}/${i}" )
                # list( APPEND ALL_SOURCES "${i}" )
            endforeach( i )
        endif( _BINARY_SOURCES )
        message( STATUS "ALL_SOURCES: ${ALL_SOURCES}" )
        #--------------------------------------------------------------------
        #
        #--------------------------------------------------------------------
        set(CMAKE_JAVA_COMPILE_FLAGS -source ${JAVA_COMPATIBILITY} -target ${JAVA_COMPATIBILITY} )
        #-------------------------------------------------------------------
        # Get source into local build directory
        #-------------------------------------------------------------------
        if ( _SOURCES )
            copy_if_different(
                ${CMAKE_CURRENT_SOURCE_DIR}
                ${CMAKE_CURRENT_BINARY_DIR}
                "${_SOURCES}"
                JavaStageTargets "JavaStage${target}" )
            add_custom_target( CopyJavaStage${target}
                ALL DEPENDS ${JavaStageTargets} )
        endif ( _SOURCES )
        #-------------------------------------------------------------------
        # Compile source
        #-------------------------------------------------------------------
        set( CMAKE_JAVA_INCLUDE_PATH ${NDS_JAR} )
        message( STATUS "DEBUG: NDS_JAR: ${NDS_JAR}" )
        add_jar( ${target}
            SOURCES ${ALL_SOURCES}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
        add_dependencies( ${target} ndstesting nds2 nds2JNI )
        if( JavaStageTargets )
            add_dependencies( ${target} CopyJavaStage${target} )
        endif( JavaStageTargets )
    endfunction(COMPILE_JAVA)

    function(COMPILE_JAVA_TEST target)
        compile_java(${target} ${ARGN} )
    endfunction(COMPILE_JAVA_TEST)

    function(ADD_JAVA_TEST target)
        list(GET ARGN 0 cmd )
        set_testing_path( )
        to_path_list(java_test_jars ${CMAKE_CURRENT_BINARY_DIR}/${cmd}.jar ${NDS_JAR} )
        add_test( ${target}
            ${Java_JAVA_EXECUTABLE} -cp ${java_test_jars} -enableassertions ${CMAKE_JAVA_EXTRA_FLAGS} ${ARGN} )
        set( env 
              "PATH=${TPATH}"
              "JAVA=${PROG_JAVA}"
              ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
        set_test_properties( ${target}
            ENVIRONMENT "${env}"
            )
    endfunction(ADD_JAVA_TEST)

    #-----------------------------------------------------------------------
    # Need to build some scripts since they depend on dynamic data.
    #-----------------------------------------------------------------------

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_java.java.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_java.java
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/test_nds2_version_matlab.m.in
                    ${CMAKE_CURRENT_BINARY_DIR}/test_nds2_version_matlab.m
                    @ONLY )

    configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/unittest.java
                    ${CMAKE_CURRENT_BINARY_DIR}/ndstesting/unittest.java
                    COPYONLY )
    #-----------------------------------------------------------------------
    #-----------------------------------------------------------------------
    compile_java(
        ndstesting
        BINARY_SOURCES
            "ndstesting/unittest.java" )
    #-----------------------------------------------------------------------
    # Run tests that depend on python
    #-----------------------------------------------------------------------
    if( PYTHON_DFLT_EXECUTABLE )
        #-------------------------------------------------------------------
        # All of these require python to run
        #-------------------------------------------------------------------
        function(null_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                if (NOT IS_ABSOLUTE ${command})
                    if ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                    elseif ( EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                        set( command "${CMAKE_CURRENT_SOURCE_DIR}/${command}")
                    endif ( EXISTS "${CMAKE_CURRENT_BINARY_DIR}/${command}")
                endif (NOT IS_ABSOLUTE ${command})
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --null-server
                        "${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                # message( FATAL_ERROR "DEBUG: env: ${env}" )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                        )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(null_server_test)

        function(mock_server_test name command)
            set( _include_test TRUE )
            get_filename_component( COMMAND_EXT ${command} EXT )
            message( STATUS "Command extension: ${COMMAND_EXT}" )
            if( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_BINARY_DIR})
            else( ${COMMAND_EXT} STREQUAL ".class" )
                set(COMMAND_DIR ${CMAKE_CURRENT_SOURCE_DIR})
            endif( ${COMMAND_EXT} STREQUAL ".class" )
            if( ${COMMAND_EXT} STREQUAL ".m" )
                if ( PROG_MATLAB )
                    list(APPEND COMMAND_OPTIONS --matlab=${PROG_MATLAB})
                    list(APPEND COMMAND_OPTIONS ${MATLAB_TEST_FLAGS})
                    list(APPEND COMMAND_OPTIONS --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar)
                else ( PROG_MATLAB )
                    set( _include_test FALSE )
                endif ( PROG_MATLAB )
            endif( ${COMMAND_EXT} STREQUAL ".m" )
            if ( _include_test )
                set_testing_path( )
                add_test(
                    NAME ${name}
                    COMMAND
                        ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                        ${COMMAND_OPTIONS}
                        --nds1-mock-server
                        "${COMMAND_DIR}/${command}" )
                set( env
                    "PATH=${TPATH}"
                    "JAVA=${PROG_JAVA}"
                    ${NDS_EXTEND_JAVA_BOOT_LIBRARY_PATH} )
                set_tests_properties( ${name}
                    PROPERTIES
                        SKIP_RETURN_CODE 77
                        ENVIRONMENT "${env}"
                          )
                set( NDS_CUSTOM_MEMCHECK_IGNORE
                    ${NDS_CUSTOM_MEMCHECK_IGNORE} ${name}
                    CACHE INTERNAL "" )
            endif ( _include_test )
        endfunction(mock_server_test)

        function(replay_server_test name command json)
            if ( REPLAY_BLOB_CACHE_DIR )
                set_nds_protocols(protocols ${name})
                foreach ( proto ${protocols} )
                    set(test_name "${name}${proto}_")
                    set( _include_test TRUE )
                    get_filename_component( COMMAND_EXT ${command} EXT )
                    if( ${COMMAND_EXT} STREQUAL ".m" )
                        if ( NOT PROG_MATLAB )
                            set( _include_test FALSE )
                        endif ( NOT PROG_MATLAB )
                    endif( ${COMMAND_EXT} STREQUAL ".m" )
                    if ( _include_test )
                        set_testing_path( )
                        add_test(
                            NAME ${test_name}
                            COMMAND
                                ${PYTHON_DFLT_EXECUTABLE} ${PROG_NDS_TESTER} ${NDS_TESTER_FLAGS}
                                --matlab=${PROG_MATLAB}
                                ${MATLAB_TEST_FLAGS}
                                --jarfiles=${CMAKE_CURRENT_BINARY_DIR}/ndstesting.jar
                                --replay-server
                                --replay-json-filename ${json}
                                --replay-protocol ${proto}
                                "${CMAKE_CURRENT_SOURCE_DIR}/${command}" ${ARGN} )
                        set( env

=== debian/changelog ===
nds2-client-swig (0.16.13-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Jonathan Hanks <jonathan.hanks@ligo.org>  Fri, 15 Aug 2025 14:30:00 -0700

nds2-client-swig (0.16.12-1.3) unstable; urgency=low

  * Updated code as described in the ChangeLog.md
  * Added --with=python3 to catch-all rule
  * Added python3-numpy dependency
  * Keep octave and python2 disabled

 -- Steffen Grunewald <steffen.grunewald@ligo.org>  Wed, 23 Aug 2023 14:00:00 +0200

nds2-client-swig (0.16.12-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Tue, 02 Aug 2022 09:48:44 -0700

nds2-client-swig (0.16.11-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Fri, 14 Jan 2022 10:02:40 -0800

nds2-client-swig (0.16.10-1) unstable; urgency=low

  * Updated code as described in the ChangeLog.md

 -- Edward Maros <ed.maros@ligo.org>  Thu, 05 Aug 2021 08:10:05 -0700

nds2-client-swig (0.16.9-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 05 May 2021 18:32:07 -0700

nds2-client-swig (0.16.8-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 13 Aug 2020 15:50:17 -0700

nds2-client-swig (0.16.7-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 19 Mar 2020 11:27:38 -0700

nds2-client-swig (0.16.6-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 27 Sep 2019 14:09:47 -0700

nds2-client-swig (0.16.5-1) unstable; urgency=low

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 07 Mar 2019 11:26:54 -0800

nds2-client-swig (0.16.4-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 20 Feb 2019 11:19:22 -0800

nds2-client-swig (0.16.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 02 Nov 2018 11:16:25 -0700

nds2-client-swig (0.16.2-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Mon, 22 Oct 2018 09:25:14 -0700

nds2-client-swig (0.16.1-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Fri, 03 Aug 2018 09:38:11 -0700

nds2-client-swig (0.16.0-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Thu, 02 Aug 2018 13:32:57 -0700

nds2-client-swig (0.15.3-1) unstable; urgency=medium

  * Updated code as described in the ChangeLog

 -- Edward Maros <ed.maros@ligo.org>  Wed, 14 Mar 2018 13:39:41 -0700

=== debian/control ===
Source: nds2-client-swig
Section: net
Priority: optional
Maintainer: Edward Maros <ed.maros@ligo.org>
Build-Depends:
 debhelper (>= 9),
 dh-python,
 cmake,
 gawk,
 pkg-config,
 swig (>= 3.0.7),
 python3-all-dev,
 python3-numpy,
 default-jdk,
 libnds2-client-dev (>= 0.16.9)
# octave | octave3.2 | octave3.0,
# liboctave-dev | octave3.2-headers | octave3.0-headers,
# python-all-dev,
# python-numpy,
Standards-Version: 3.9.8
#X-Python-Version: >= 2.7
X-Python3-Version: >= 3.5
Homepage: https://wiki.ligo.org/Computing/NDSClient

Package: nds2-client-swig
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 krb5-user
Suggests:
 libnds2-client-java,
 libnds2-client-matlab,
 python3-nds2-client
# octave-nds2-client,
# python-nds2-client,
Description: NDS2 client binaries
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes some client binary examples.

Package: libnds2-client-java
Section: java
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client java interface
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated java bindings, which are
 also usable from Matlab.

# Package: octave-nds2-client
# Architecture: any
# Depends:
#  libnds2-client (>= 0.16.9),
#  octave,
#  ${shlibs:Depends},
#  ${misc:Depends}
# Description: NDS2 client octave bindings
#  The Network Data Server (NDS) is a TCP/IP protocol for retrieving
#  online or archived data from thousands of instrument channels at LIGO
#  (Laser Interferometer Gravitational-Wave Observatory) sites and data
#  analysis clusters.  Version 2 of the protocol includes communication
#  with Kerberos and GSSAPI.
#  .
#  This package includes the SWIG-generated octave bindings.

#Package: python-nds2-client
#Section: python
#Architecture: any
#Depends: ${python:Depends},
# libnds2-client (>= 0.16.9),
# ${shlibs:Depends},
# ${misc:Depends}
#Description: NDS2 client Python bindings
# The Network Data Server (NDS) is a TCP/IP protocol for retrieving
# online or archived data from thousands of instrument channels at LIGO
# (Laser Interferometer Gravitational-Wave Observatory) sites and data
# analysis clusters.  Version 2 of the protocol includes communication
# with Kerberos and GSSAPI.
# .
# This package includes the SWIG-generated python bindings.

Package: python3-nds2-client
Section: python
Architecture: any
Depends: ${python3:Depends},
 libnds2-client (>= 0.16.9),
 python3-numpy,
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client Python 3 bindings
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package includes the SWIG-generated python bindings.

Package: libnds2-client-matlab
Architecture: any
Depends:
 libnds2-client-java (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: NDS2 client MATLAB interface
 This provides MATLAB wrappers for the nds2 client

Package: nds2-client-swig-all
Architecture: any
Depends:
 ${misc:Depends},
 libnds2-client-java (= ${binary:Version}),
 libnds2-client-matlab (= ${binary:Version}),
 python3-nds2-client (= ${binary:Version})
# octave-nds2-client (= ${binary:Version}),
# python-nds2-client (= ${binary:Version}),
Description: NDS2 meta package
 The Network Data Server (NDS) is a TCP/IP protocol for retrieving
 online or archived data from thousands of instrument channels at LIGO
 (Laser Interferometer Gravitational-Wave Observatory) sites and data
 analysis clusters.  Version 2 of the protocol includes communication
 with Kerberos and GSSAPI.
 .
 This package installs all NDS2 client packages, including libraries,
 language bindings, binary interface, and documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --with=python3

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_INSTALL_SYSCONFDIR=etc -DCMAKE_INSTALL_FULL_SYSCONFDIR=/etc -DENABLE_SWIG_OCTAVE=FALSE -DENABLE_SWIG_PYTHON2=no -DENABLE_SWIG_PYTHON3=yes
